/* hexe - function.c
 Copyright (C) 2010 spinout
   rmo@spinout182.com
   spinout182.com
 Feel free to modify and redestribute as you like,
 so long that all that have contributed are given
 due credit for their contributions and the code that
 you got is just as avalible
 
 If you just want a snippet, feel free to take it.
*/

#include "hexe.h"


/* bottom up memcpy */
void rmemcpy(unsigned char * dest, unsigned char * src, int siz)
{
    siz--;
    do{
       dest[siz] = src[siz];
       siz--;
    }while(siz >= 0);
}

int find_next(unsigned char * haystack, unsigned char * needle, int start_pos, int needle_len, int haystack_len, int align)
{
    int end_pos;
    start_pos &= 0xFFFFFFFF ^ (align-1);
    end_pos = haystack_len - needle_len;
    for(;start_pos<end_pos;start_pos+=align)
    {
        if(*(haystack+start_pos) == *needle && !memcmp(haystack+start_pos, needle, needle_len))
            return start_pos;
    }
    return -1;
}

int find_previous(unsigned char * haystack, unsigned char * needle, int start_pos, int needle_len, int align)
{
    start_pos &= 0xFFFFFFFF ^ (align-1);
    for(;start_pos>0;start_pos-=align)
    {
        if(*(haystack+start_pos) == *needle && !memcmp(haystack+start_pos, needle, needle_len))
            return start_pos;
    }
    return -1;
}
