/* hexe - hexe.c
 Copyright (C) 2010 spinout
   rmo@spinout182.com
   spinout182.com
 Feel free to modify and redestribute as you like,
 so long that all that have contributed are given
 due credit for their contributions and the code that
 you got is just as avalible
 
 If you just want a snippet, feel free to take it.
*/

#include "hexe.h"

int colsize=4, addr=0, low=0, max_addr=0, curr_min=0, curr_max=0, unsaved_changes=0, read_only=0;
int bytegroup=4;
int maxx, maxy, key, mode;
unsigned char * data=NULL;
char * curr_mode_s;
char *fn;
int hlmax, hlmin;

void quit()
{
    endwin();
    free(fn);
    free(data);
    exit(0);
}

int
main(int argc, char ** argv)
{
    int result,i;
    
    if(argc>1)
    {
        if(argc>2){
            for(i=1;i<argc-1;i++)
            {
                if(!strncmp(argv[i], "--no-cols=",10))
                    sscanf(argv[i], "--no-cols=%i", &colsize);
                else if(!strcmp(argv[i], "-c"))
                    sscanf(argv[++i], "%i", &colsize);
                else if(*argv[i] == '+' && strlen(argv[i]) > 1 && sscanf(argv[i], "+%X", &result) == 1)
                    addr = result;
                else if(!strcmp(argv[i], "-v") || !strcmp(argv[i], "--view"))
                    read_only = 1;
                else if(!strncmp(argv[i], "--byte-groups=", 14))
                {
                    sscanf(argv[i], "--byte-groups=%i", &bytegroup);
                  bytegroup_check:
                    switch(bytegroup)
                    {
                    case 1:
                    case 2:
                    case 4:
                    case 8:
                    case 16:
                        break;
                    default:
                        bytegroup=4;
                        break;
                    }
                }
                else if(!strcmp(argv[i], "-c"))
                {
                    sscanf(argv[++i], "%i", &bytegroup);
                    goto bytegroup_check;
                }
                else if(help_check(argv[i]))
                {
                  help:
                    printf("Usage: %s [OPTIONS] [FILE]\n\n", argv[0]);
                    printf("Option            Long option             Meaning\n");
                    printf(" -h,-?            --help                  Show this message\n");
                    printf(" -b <count>       --byte-groups=<count>   Set the width of byte groups\n");
                    printf(" -c <count>       --no-cols=<count>       Set the number of columns\n");
                    printf(" +ADDRESS                                 Start at ADDRESS (hexadecmial)\n");
                    printf(" -v               --view                  View mode (read-only)\n");
                    exit(EXIT_FAILURE);
                }
                else
                {
                    printf("Error: unknown option `%s'\n", argv[i]);
                    goto help;
                }
            }
        }
        if(help_check(argv[argc-1]))
            goto help; 
        fn = malloc(strlen(argv[argc-1]));
        strcpy(fn, argv[argc-1]);
        data = NULL;
        if(load_f())
            load_dummy();
    }
    else
        load_dummy();
    
    colsize *= bytegroup;
    bytegroup--;
    
    initscr();
    start_color();
    noecho();
    raw();
    cbreak();
    timeout(0);
    keypad(stdscr, 1);
    
    init_color_pairs();
    
    while(1)
    {
        getmaxyx(stdscr, maxy, maxx);
        maxy--;
        maxx--;

        print_rows();
        print_ui();

        if((key = getch()) != -1)
            key_handler(key);
        
        move(maxx, maxy);
        usleep(10000);
    }
    
    return 0;
}
