/* hexe - hexe.h
 Copyright (C) 2010 spinout
   rmo@spinout182.com
   spinout182.com
 Feel free to modify and redestribute as you like,
 so long that all that have contributed are given
 due credit for their contributions and the code that
 you got is just as avalible
 
 If you just want a snippet, feel free to take it.
*/

#include <curses.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <ctype.h>

#ifndef __HEXE_H__
 #define __HEXE_H__

/* macros / constants
*/
#define SET_COLOR(fore, bg)                wattrset(stdscr, COLOR_PAIR(COLOR_##fore * COLORS + COLOR_##bg))
#define help_check(arg)	(!strcmp(arg, "--help") || !strcmp(arg, "-?") || !strcmp(arg, "-h"))

#define PG_DOWN	338
#define PG_UP	339
#define END	360
#define CTRL(x)	x - '@'
#define CTRLF	6
#define CTRLG	7
#define BACKSPACE	263

/* mode flags */
#define OVERWRITE	0	/* dummy */
#define INSERT		1
#define HEX		0	/* dummy */
#define TEXT		2

#define NCTRLS	7

/* variables
*/
char * ctrls[NCTRLS * 2];
unsigned char * data;
char * curr_mode_s;
char *fn;
int colsize, addr, low, max_addr, curr_min, curr_max, unsaved_changes, read_only;
int bytegroup;
int hlmax, hlmin;
int maxx, maxy, key, mode;

/* function declarations
*/
/* hexe.c */
extern void quit();
/* ui_function.c */
extern void init_color_pairs();
extern void inline blank_line(int line);
extern void get_input(char *dest, char *default_val, int maxsize, int minchar, int maxchar, int height);
extern void get_hex_str(char *dest, char * default_val, int maxsize, int y, int x);
extern void wait_message(char * msg);
/* ui.c */
extern void save_yesno();
extern void go_to();
extern void insert();
extern void key_handler();
extern void search();
extern void print_rows();
extern void print_ui();
/* function.c */
extern void rmemcpy(unsigned char * dest, unsigned char * src, int siz);
extern int find_next(unsigned char * haystack, unsigned char * needle, int start_pos, int needle_len, int haystack_len, int align);
extern int find_previous(unsigned char * haystack, unsigned char * needle, int start_pos, int needle_len, int align);
/* io.c */
extern void open();
extern void save();
extern int load_f();
extern void load_dummy();

#endif /* __HEXE_H__ */
