/* hexe - io.c
 Copyright (C) 2010 spinout
   rmo@spinout182.com
   spinout182.com
 Feel free to modify and redestribute as you like,
 so long that all that have contributed are given
 due credit for their contributions and the code that
 you got is just as avalible
 
 If you just want a snippet, feel free to take it.
*/

#include "hexe.h"

void open()
{
    char in[512];
    char *fnold;
    int r;
    
    fnold = malloc(strlen(fn));
    strcpy(fnold, fn);
    
    blank_line(maxy-1);
    blank_line(maxy);
    SET_COLOR(WHITE, BLACK);
    mvprintw( maxy-1, 0, "File to open:");
    get_input(in, NULL, 512, ' ', '~', maxy);
    if(!*in) goto end;
    
    fn = realloc(fn, strlen(in));
    strcpy(fn, in);
    if((r = load_f()) <0 )
    {
        if(r == -1)
        {
            blank_line(maxy);
            SET_COLOR(WHITE, RED);
            mvprintw(maxy-1, 0, "Error opening file. Current file will stay open.");
            usleep(1000);
            refresh();
            sleep(2);
            fn = realloc(fn, strlen(fnold));
            strcpy(fn, fnold);
        }
        else
        {
            blank_line(maxy);
            SET_COLOR(WHITE, RED);
            mvprintw(maxy-1, 0, "Error while reading file.");
            usleep(1000);
            refresh();
            sleep(2);
            
            load_dummy();
        }
    }
  end:
    free(fnold);
}

void save()
{
    char in[512];
    FILE *f;
    
    blank_line(maxy-1);
    blank_line(maxy);
    SET_COLOR(WHITE, BLACK);
    mvprintw( maxy-1, 0, "Save as:");
    get_input(in, fn, 512, ' ', '~', maxy);
    if(!*in) return;
    
    f = fopen(in, "wb");
    if(f == NULL)
    {
        mvprintw(maxy, 0, "Error opening file to write to");
        sleep(2);
        return;
    }
    if(fwrite(data, max_addr, 1, f)!=max_addr)
    {
        mvprintw(maxy, 0, "Error writing data to file");
        sleep(2);
    }
    unsaved_changes = 0;
}

int load_f()
{
    int siz;
    FILE *f = fopen(fn, "rb");
    if(f == NULL)
        return -1;
    fseek(f, 0, SEEK_END);
    siz = ftell(f);
    rewind(f);
    if(data != NULL)
        free(data);
    data = malloc(siz);
    if(data == NULL)
        return -2;
    max_addr = siz;
    fread(data, max_addr, 1, f);
    if(addr >= max_addr)
        addr = max_addr-1;
    fclose(f);
    mode = OVERWRITE|HEX;
    return 0;
}

void load_dummy()
{
    char tmpname[12];
    sprintf(tmpname, "%ld", time(NULL));
    fn = malloc(strlen(tmpname));
    strcpy(fn, tmpname);
    data = NULL;
    mode = INSERT|HEX;
    max_addr=0;
    addr=0;
}

