/* hexe - ui_function.c
 Copyright (C) 2010 spinout
   rmo@spinout182.com
   spinout182.com
 Feel free to modify and redestribute as you like,
 so long that all that have contributed are given
 due credit for their contributions and the code that
 you got is just as avalible
 
 If you just want a snippet, feel free to take it.
*/

#include "hexe.h"

void init_color_pairs()
{
    short f, b;
    for( f = 0; f < COLORS; ++f )
    {
        for( b = 0; b < COLORS; ++b )
        {
            init_pair( f * COLORS + b, f, b );
        }
    }
}

void inline blank_line(int line)
{
    char d[maxx+1];
    memset(d, ' ', maxx);
    d[maxx] = 0;
    SET_COLOR(BLACK, BLACK);
    mvprintw(line, 0, d);
}

void get_input(char *dest, char *default_val, int maxsize, int minchar, int maxchar, int height)
{
    int i=0,c;
    memset(dest, 0, maxsize);
    blank_line(height);
    if(default_val !=NULL)
    {
        i=strlen(default_val);
        strcpy(dest, default_val);
        mvprintw( height, 0, default_val);
    }
    
    while(1)
    {
        move(height, i);
        while((c=getch())==-1) usleep(5000);
        
        if(c >= minchar && c <= maxchar && i<maxsize)
        {
            if(!dest[i]) dest[i+1] = 0;
            dest[i]=c;
            mvaddch(height, i, c);
            i++;
        }
        
        else if(c == KEY_LEFT && i)
            i--;
        
        else if(c == KEY_RIGHT && i<maxsize )
            i++;
        
        else if(i && (c==BACKSPACE || c=='\b'))
        {
            mvaddch(height, --i, ' ');
            dest[i]=0;
        }
        
        else if(c=='\n' || c==EOF)
            break;
    }
}

void get_hex_str(char *dest, char * default_val, int maxsize, int y, int x)
{
    
    int i=0, c;
    memset(dest, 0, maxsize);
    
    if(default_val !=NULL)
    {
        i=strlen(default_val);
        strcpy(dest, default_val);
        mvprintw( y, 0, default_val);
    }
    
    while(1)
    {
        move(y, i + x);
        while((c=getch())==-1) usleep(5000);
        
        c=toupper(c);

        if(((c>='0' && c<='9') || (c>='A' && c<='F') || (i==1 && c =='X' && (c=tolower(c)))) && i<maxsize )
        {
            dest[i]=c;
            dest[i+1] = 0;
            mvaddch(y, i+x, c);
            i++;
        }
        
        else if(c == KEY_LEFT && i)
            i--;
        
        else if(c == KEY_RIGHT && i<maxsize)
            i++;
        
        else if(i && (c==BACKSPACE || c=='\b'))
        {
            mvaddch(y, (--i)+x, ' ');
            dest[i]=0;
        }
        
        else if(c=='\n' || c==EOF)
            break;
    }
}

void wait_message(char * msg)
{    
    blank_line(maxy-1);
    blank_line(maxy);
    mvprintw( maxy-1, 0, msg);
    move(maxy,maxx);
    refresh();
    usleep(500);
    refresh();
    sleep(2);
}
